<?php
/* Copyright 2008-2009 Vincent Prat */


/**
* View to reset passwords
* 
* @author Vincent Prat
*/
class UMPR_PasswordResetPage {

    /**
    * Constructor
    */
    function UMPR_PasswordResetPage() {
    }
	
    /**
    * Show the view
    */
    function show_view() {
        global $umpr_plugin, $user_ID, $um_plugin, $wp_roles;  
		
		$role = empty($_POST["role"]) ? '' : $_POST["role"];
		$allowed_chars = empty($_POST["allowed_chars"]) ? $umpr_plugin->options["allowed_chars"] : $_POST["allowed_chars"];
		$password_length = empty($_POST["password_length"]) ? $umpr_plugin->options["password_length"] : $_POST["password_length"];
		$notification_subject = empty($_POST["notification_subject"]) ? $umpr_plugin->options["notification_subject"] : $_POST["notification_subject"];
		$notification_body = empty($_POST["notification_body"]) ? $umpr_plugin->options["notification_body"] : $_POST["notification_body"];
						
		if (isset($_POST["reset_passwords"])) {			
        	check_admin_referer("umpr_reset_passwords");
			
			if (empty($_POST["role"])) {
?>
		<div id="error" class="error fade"><?php _e("No role selected!","umpr"); ?></div>
<?php			
			} else if (empty($_POST["allowed_chars"])) {
?>
		<div id="error" class="error fade"><?php _e("No allowed characters selected!","umpr"); ?></div>
<?php			
			} else if (empty($_POST["password_length"])) {
?>
		<div id="error" class="error fade"><?php _e("No password length selected!","umpr"); ?></div>
<?php			
			} else if (empty($_POST["notification_subject"])) {
?>
		<div id="error" class="error fade"><?php _e("No notification subject!","umpr"); ?></div>
<?php			
			} else if (empty($_POST["notification_body"])) {
?>
		<div id="error" class="error fade"><?php _e("No notification body!","umpr"); ?></div>
<?php			
			} else {
				$result = $umpr_plugin->reset_role_passwords($role, $password_length, $allowed_chars, $notification_subject, $notification_body);
?>
				<div id="message" class="updated fade">
					<?php echo sprintf(__("%d user(s) will be sent a new password. The emails have been queued by User Messages and the password will be resetted when the email gets sent.", "umpr"), count($result)); ?><br/>
				</div>
<?php		}
        }
?>


<div class="wrap">
    <h2><?php echo sprintf(__("Password Reset for User Messages - %s", "umpr"), $umpr_plugin->options['active_version']); ?> 
	(<a href="<?php echo admin_url('tools.php?page=um-password-reset&view=umpr-plugin-about-view'); ?>"><?php _e('About', 'umpr') ;?></a>)</h2>
        
<?php 
	if (!isset($um_plugin)) { 
?>
	<div id="error" class="error fade">
		<?php _e("User Messages is not active!","umpr"); ?>
		<?php echo __("You can buy the plugin there: ", "umpr"); ?><a href="http://user-messages.marvinlabs.com/">User Messages</a>
	</div>
</div>
<?php 
		return;
	} else if (strcmp($um_plugin->options['active_version'], '2.5.0')<0) { 
?>
	<div id="error" class="error fade">
		<?php echo __("This plugin needs at least User Messages 2.5.0", "umpr"); ?>
		<?php echo __("You can buy the plugin there: ", "umpr"); ?><a href="http://user-messages.marvinlabs.com/">User Messages</a>
	</div>
</div>
<?php 
		return;
	} 
?>
	<p style="font-weight: bold; color: #CC3333; font-size: 1.5em;">
	<?php echo __("It is <strong>HIGHLY</strong> recommended that you setup one or two fake users having a role which is not used by anybody else!", "umpr"); ?> 
	<?php echo __("You can use the following plugin if you need to create fake roles for testing purpose: ", "umpr"); ?><a href="http://www.shinephp.com/user-role-editor-wordpress-plugin/">User Role Editor</a>
	</p>

        <form action="" method="post">
            <?php wp_nonce_field('umpr_reset_passwords') ?> 
            <input type="hidden" name="option_names" value="user_quota" />  
					       
			<table class="form-table um-msg">
				<tr valign="top">
					<th scope="row"><?php _e('Target Role', 'umpr') ?></th>
					<td>   
						<select name='role'>
					<?php 
						$roles = $umpr_plugin->get_roles_of_blog(); 
						foreach ($roles as $r) {
					?>
							<option value="<?php echo $r->name; ?>" <?php if (0==strcmp($role, $r->name)) echo 'selected="selected"'; ?>>
								<?php echo $r->name; ?>
							</option>
					<?php
						}
					?>	
						</select>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('Allowed characters', 'umpr') ?></th>
					<td>                                                                            
						<input type="text" name="allowed_chars" value="<?php echo $allowed_chars; ?>" class="wide" />
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('Password Length', 'umpr') ?></th>
					<td>                                                                            
						<input type="text" name="password_length" value="<?php echo $password_length; ?>" class="" />
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('Sample password', 'umpr') ?></th>
					<td>                                                                            
						<?php echo $umpr_plugin->get_random_password($password_length, $allowed_chars); ?>
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('Email Subject', 'umpr') ?></th>
					<td>                                                                            
						<input type="text" name="notification_subject" value="<?php echo htmlspecialchars($notification_subject); ?>" class="wide subject" />
					</td>
				</tr>
				<tr valign="top">
					<th scope="row"><?php _e('Email Body', 'umpr') ?></th>
					<td>                       
						<textarea name="notification_body" rows="15" class="wide"><?php 
							echo htmlspecialchars($notification_body);
						?></textarea>                          
					</td>
				</tr>
			</table>

            <table class="form-table um-msg">
				<tr valign="top">
                    <th scope="row"></th>
                    <td><p style="font-weight: bold; color: #CC3333; font-size: 2em;"><?php _e("Caution! Think twice! Double Check! No undo will be possible!", "umpr"); ?></p></td>
                </tr>
                <tr valign="top">
                    <th scope="row"></th>
                    <td><input type="submit" name="reset_passwords" value="<?php _e("Reset Passwords", "umpr"); ?>" class="button-primary" /></td>
                </tr>
                <tr valign="top">
                    <th scope="row"></th>
                    <td></td>
                </tr>
            </table>
        </form>    
</div>
<?php        
    }
}
  